package org.objectweb.petals.engine.performance.provider;

import java.util.logging.Logger;

import javax.jbi.JBIException;
import javax.jbi.component.ComponentContext;
import javax.jbi.component.ComponentLifeCycle;
import javax.jbi.component.ServiceUnitManager;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.servicedesc.ServiceEndpoint;
import javax.management.ObjectName;
import javax.xml.namespace.QName;

import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;

import org.objectweb.petals.component.common.util.WSDLHelper;

public class Component implements javax.jbi.component.Component,
    ComponentLifeCycle {

    private Receiver receiver;
    private ObjectName name; 
    private ComponentContext context;
    private ServiceEndpoint providerEndpoint;
    private Document description;
    
    public ComponentLifeCycle getLifeCycle() {
        // TODO Auto-generated method stub
        return this;
    }

    /**
     * return a wsdl2.0 light doc for PerfEndpoint
     */
    public Document getServiceDescription(ServiceEndpoint endpoint) {
        if(endpoint.getServiceName().equals(providerEndpoint.getServiceName())
                && endpoint.getEndpointName().equals(providerEndpoint.getEndpointName())){
            return description;
        }
        return null;
    }

    public ServiceUnitManager getServiceUnitManager() {
        // TODO Auto-generated method stub
        return null;
    }

    public boolean isExchangeWithConsumerOkay(ServiceEndpoint endpoint,
        MessageExchange exchange) {
        // TODO Auto-generated method stub
        return false;
    }

    public boolean isExchangeWithProviderOkay(ServiceEndpoint endpoint,
        MessageExchange exchange) {
        // TODO Auto-generated method stub
        return false;
    }

    public ServiceEndpoint resolveEndpointReference(DocumentFragment epr) {
        // TODO Auto-generated method stub
        return null;
    }

    public ObjectName getExtensionMBeanName() {
        return  name;
    }

    public void init(ComponentContext context) throws JBIException {
        receiver = new Receiver();
        this.context=context;
        receiver.context=context;
        receiver.channel=context.getDeliveryChannel();
        Logger logger = context.getLogger("", null);
        receiver.logger = logger;
        name = context.getMBeanNames().createCustomComponentMBeanName("perfProviderComponent");
        try {
            context.getMBeanServer().registerMBean(receiver, name);
        } catch (Exception e) {
            e.printStackTrace();
            throw new JBIException(e);
        }
    }

    public void shutDown() throws JBIException {
        try {
            context.getMBeanServer().unregisterMBean(name);
        } catch (Exception e) {
            e.printStackTrace();
            throw new JBIException(e);
        }

    }

    /**
     * Register a perfEndpoint
     */
    public void start() throws JBIException {
        QName interfaceName=QName.valueOf("{http://petals.objectweb.org}PerfProvider");
        QName serviceName=QName.valueOf("{http://petals.objectweb.org}PerfProviderService");
        String endpointName="MockPerfProviderEndpoint";
        providerEndpoint = context.activateEndpoint(serviceName, endpointName);
        description = WSDLHelper.createLightWSDL20(interfaceName, serviceName, endpointName);
    }

    public void stop() throws JBIException {
        context.deactivateEndpoint(providerEndpoint);
        // force the stop of the Accept tasks if still running
        if ( receiver != null &&
                receiver.scheduledThreadPoolExecutor != null &&
                !receiver.scheduledThreadPoolExecutor.isShutdown()) {
            receiver.stopAccepting();
        }
    }

}
