package org.objectweb.petals.engine.performance.provider;

public interface ReceiverMBean {

    public abstract int getThreadCount();

    public abstract void setThreadCount(int threadCount);

    public abstract int getAcceptTimeout();

    public abstract void setAcceptTimeout(int acceptTimeout);
    
    public abstract boolean isProcessInContent();

    public abstract void setProcessInContent(boolean processInContent);

    public abstract long getAcceptedMessageCount();

    public abstract long getNotAcceptedMessageCount();

    public abstract long getNotSentResponseCount();

    public abstract long getSentResponseCount() ;
    
    /**
     * Start accepting Messages and send back response if needed.
     */
    public abstract void startAccepting() throws Exception;

    /**
     * Stop accepting Messages.
     */
    public abstract void stopAccepting();

    /**
     * Reset the Counters
     */
    public abstract void resetCounters();

}